Ruby 1.9.2p136(2010-12-25revision30365)

- Main Page
- Modules
- Data Structures
- Files

- File List
- Globals

Data Structures | Defines | Functions

# ext/io/wait/wait.c File Reference

`#include "ruby.h"`
`#include "ruby/io.h"`
`#include <sys/types.h>`
Include dependency graph for wait.c:

Go to the source code of this file.

## Data Structures
struct | wait_readable_arg
## Defines
#define | ioctl_arg int
#define | ioctl_arg2num(i) INT2NUM(i)
#define | FIONREAD_POSSIBLE_P(fd) ((void)(fd),Qtrue)
## Functions
static VALUE io_ready_p | _ ((VALUE io))
static VALUE io_wait | _ ((int argc, VALUE *argv, VALUE io))
void Init_wait | _ ((void))
EXTERN struct timeval rb_time_interval | _ ((VALUE time))
static VALUE | io_nread (VALUE io)
static VALUE | io_ready_p (VALUE io)
static VALUE | io_wait (int argc, VALUE *argv, VALUE io)
void | Init_wait ()

## Define Documentation

#define FIONREAD_POSSIBLE_P | ( |  | fd | ) | ((void)(fd),Qtrue)

Definition at line 36 of file wait.c.

Referenced by io_nread(), io_ready_p(), and io_wait().

#define ioctl_arg int

Definition at line 29 of file wait.c.

Referenced by io_nread(), io_ready_p(), and io_wait().

#define ioctl_arg2num | ( |  | i | ) | INT2NUM(i)

Definition at line 30 of file wait.c.

Referenced by io_nread().

## Function Documentation

static VALUE io_ready_p _ | ( | (VALUE io) |  | ) | `[static]`

static VALUE io_wait _ | ( | (int argc, VALUE *argv, VALUE io) |  | ) | `[static]`

EXTERN struct timeval rb_time_interval _ | ( | (VALUE time) |  | ) | `[read]`

void Init_wait _ | ( | (void) |  | ) |

void Init_wait | ( |  | ) |

Definition at line 163 of file wait.c.

References io_nread(), io_ready_p(), io_wait(), rb_cIO, and rb_define_method().

static VALUE io_nread | ( | VALUE | io | ) | `[static]`

Definition at line 54 of file wait.c.

References rb_io_t::fd, FIONREAD_POSSIBLE_P, GetOpenFile, INT2FIX, ioctl(), ioctl_arg, ioctl_arg2num, len, rb_io_check_readable(), and rb_io_read_pending().

Referenced by Init_wait().

static VALUE io_ready_p | ( | VALUE | io | ) | `[static]`

Definition at line 79 of file wait.c.

References rb_io_t::fd, FIONREAD_POSSIBLE_P, GetOpenFile, ioctl(), ioctl_arg, Qfalse, Qnil, Qtrue, rb_io_check_readable(), and rb_io_read_pending().

Referenced by Init_wait().

static VALUE io_wait | ( | int | argc,
|  | VALUE * | argv,
|  | VALUE | io
| ) |  | `[static]`

Definition at line 119 of file wait.c.

References _, rb_io_t::fd, wait_readable_arg::fds, FIONREAD_POSSIBLE_P, GetOpenFile, ioctl(), ioctl_arg, NIL_P, NULL, Qfalse, Qnil, Qtrue, rb_ensure(), rb_fd_init, rb_fd_ptr, rb_fd_set, rb_fd_term, rb_io_check_closed(), rb_io_check_readable(), rb_io_read_pending(), rb_scan_args(), rb_sys_fail(), rb_thread_select(), rb_time_interval(), and wait_readable_arg::timeout.

Referenced by Init_wait().